//=====================================================================================================================
/// @file		SPI_ATmega328p.h
///
/// @brief		Variables and Functions for SPI Interface of ATmega328p
///
/// @version	V1.0
///
/// @date		01.08.2020
///
/// @author		Philipp Holle
//=====================================================================================================================
#ifndef SPI_ATmega328p_H_
#define SPI_ATmega328p_H_
//---------------------------------------------------------------------------------------------------------------------
// Includes
//---------------------------------------------------------------------------------------------------------------------
#include <avr/io.h>
#include <stdbool.h>
#include "ph_auxiliaries.h"
//---------------------------------------------------------------------------------------------------------------------
// Defines
//---------------------------------------------------------------------------------------------------------------------
#define PRINT_LED(a)		PORTC = (a & ~(3<<6)); PORTD = (((a>>6)&3)<<3);
//---------------------------------------------------------------------------------------------------------------------
// Macros
//---------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------------------
// Global variables
//---------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------------------
// Prototypes of global functions
//---------------------------------------------------------------------------------------------------------------------
//Initialize SPI Interface (Master)
void SpiInitMaster(void);
//Transceive Data Array via SPI (Master)
bool SpiTransceiveMaster(uint8_t *firstElementOfSendData, uint8_t *firstElementOfRecData, uint8_t numberOfElements);
//Initialize SPI Interface (Slave)
void SpiInitSlave(void);
//Transceive Data Array via SPI (Slave)
bool SpiTransceiveSlave(uint8_t *sendData, uint8_t *recData);
#endif
