//=====================================================================================================================
/// @file		.c
///
/// @brief
///
/// @version	V1.0
///
/// @date
///
/// @author		
//=====================================================================================================================

//---------------------------------------------------------------------------------------------------------------------
// Includes
//---------------------------------------------------------------------------------------------------------------------
#include <stdint.h>
#include <stdlib.h>

#include <avr/io.h>
#include "STACKTEST.h"
#include "UART_atmega328p.h"
//---------------------------------------------------------------------------------------------------------------------
// Global variables
//---------------------------------------------------------------------------------------------------------------------
extern uint8_t __bss_end;			// lowest stack address

extern uint8_t __stack;			// highest stack address
//---------------------------------------------------------------------------------------------------------------------
// Global functions
//---------------------------------------------------------------------------------------------------------------------

uint16_t stack_size( void )			// available stack
{
	return (uint16_t)&__stack - (uint16_t)&__bss_end + 1;
}


uint16_t stack_free( void )			// unused stack after last call
{
	uint8_t flag = 1;
	uint16_t i, free = 0;
	uint8_t * mp = &__bss_end;

	for( i = SP - (uint16_t)&__bss_end + 1; i; i--){
		if( *mp != FREE_MARK )
		flag = 0;
		free += flag;
		*mp++ = FREE_MARK;
	}
	return free;
}

void initStackTest(void)
{
	stack_free();
}


void checkFreeStack(void)
{
	uint16_t freeStack;
	uint16_t stackSize;
	uint8_t freeStackArray[2];
	uint8_t stackSizeArray[2];
	freeStack = stack_free();
	freeStackArray[0] = freeStack>>8;
	freeStackArray[1] = freeStack;
	stackSize = stack_size();
	stackSizeArray[0] = stackSize>>8;
	stackSizeArray[1] = stackSize;
	UartPrintLine("Free Stack: ", &freeStackArray[0],2);
	UartPrintLine(" of ", &stackSizeArray[0],2);
	UartPrintNewLine();
}


