
//=====================================================================================================================
/// @file		UART_atmega328p.h
///
/// @brief		Variables and Functions for UART Interface of ATmega328p
///
/// @version	V1.0
///
/// @date
///
/// @author		Philipp Holle
//=====================================================================================================================
#ifndef UART_ATMEGA328P_H_
#define UART_ATMEGA328P_H_
//---------------------------------------------------------------------------------------------------------------------
// Includes
//---------------------------------------------------------------------------------------------------------------------
#include <stdint.h>
#include <avr/io.h>
#include <string.h>
#include "ph_auxiliaries.h"
//---------------------------------------------------------------------------------------------------------------------
// Defines
//---------------------------------------------------------------------------------------------------------------------
#define PRINT_LED(a)		PORTC = (a & ~(3<<6)); PORTD = (((a>>6)&3)<<3);
//---------------------------------------------------------------------------------------------------------------------
// Macros
//---------------------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------------------
// Global variables
//---------------------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------------------
// Prototypes of global functions
//---------------------------------------------------------------------------------------------------------------------
void UartInit(uint8_t clockFreq, uint32_t baud);
void UartTransmit (uint8_t *firstElementOfData, uint8_t lengthOfData);
void UartPrintText (char output[]);
void UartPrintData (uint8_t *firstElementOfData, uint8_t lengthOfData);
void UartPrintNewLine();
void UartPrintLine(char text[], uint8_t* data, uint8_t dataSize);
#endif
