
//=====================================================================================================================
/// @file		atmega328p.h
///
/// @brief		Variables and functions for using features of the Atmel ATmega328p MCU
///
/// @version	V1.0
///
/// @date		05.11.20
///
/// @author		Philipp Holle
//=====================================================================================================================
#ifndef ATMEGA328P_H_
#define ATMEGA328P_H_
//---------------------------------------------------------------------------------------------------------------------
// Includes
//---------------------------------------------------------------------------------------------------------------------
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdbool.h>
#include "ph_auxiliaries.h"
//---------------------------------------------------------------------------------------------------------------------
// Defines
//---------------------------------------------------------------------------------------------------------------------
#define PRINT_LED(a)		PORTC = (a & ~(3<<6)); PORTD = (((a>>6)&3)<<3);
//---------------------------------------------------------------------------------------------------------------------
// Macros
//---------------------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------------------
// Global variables
//---------------------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------------------
// Prototypes of global functions
//---------------------------------------------------------------------------------------------------------------------
void Atmega328pInit (uint8_t clockFreq);
void Atmega328pTimerInit(uint8_t clockFreq);
void Atmega328pDelay(uint16_t msDelay);
void Atmega328pStopWatchStart(uint16_t msDelay);
bool Atmega328pStopWatchCheck();


#endif
